import * as SERVER from '@minecraft/server';

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:xadrier_corrupt', {
        onRandomTick: e => corruptX(e.block),
        onPlayerDestroy: e => corruptX(e.block)
    });
});
//


function corruptX(block) {
  block.dimension.getEntities({ location: block.location, maxDistance: 12 })
        .forEach(entity => {
            if (entity.typeId !== 'minecraft:player' && entity.typeId !== 'minecraft:item'&& entity.typeId !== 'xaierg:xadurgie' && entity.typeId !== 'xaierg:bomba_funcida' && entity.typeId !== 'xaierg:meteoro_smile2' && entity.typeId !== 'xaierg:riflef_m' && entity.typeId !== 'xaierg:riflef' && entity.typeId !=='xaierg:necrocordyceps_xadrier' && entity.typeId !== 'xaierg:lanzallamas_t' && entity.typeId !== 'xaierg:meteoro_smile' && entity.typeId !== 'xaierg:pist_m' && entity.typeId !== 'xaierg:pist' && entity.typeId !== 'xaierg:escopeta_m' && entity.typeId !== 'xaierg:escopeta' && entity.typeId !== 'xaierg:es_r_m' && entity.typeId !== 'xaierg:es_r' && entity.typeId !== 'xaierg:bala_npc' && entity.typeId !== 'xaierg:ametralladora' && entity.typeId !== 'xaierg:ametralladora_m' && entity.typeId !== 'xaierg:awm_m' && entity.typeId !== 'xaierg:awm' && entity.typeId !== 'xaierg:rifle' && entity.typeId !== 'xaierg:rifle_m' && entity.typeId !== 'xaierg:eyes_xadurgie' && entity.typeId !== 'xaierg:dead_soul' && entity.typeId !== 'xaierg:daico_hunger_x' && entity.typeId !== 'xaierg:android' && entity.typeId !== 'xaierg:entity_absorber' && entity.typeId !== 'xaierg:variant_c_smile3_child'&& entity.typeId !== 'xaierg:variant_a_child' && entity.typeId !== 'xaierg:variant_a_smile_child' && entity.typeId !== 'xaierg:variant_a_smile2_child' && entity.typeId !== 'xaierg:variant_a_smile3_child' && entity.typeId !== 'xaierg:variant_a_smile4_child'&& entity.typeId !== 'xaierg:variant_a_death_child'&& entity.typeId !=='xaierg:variant_c_smile6' && entity.typeId !== 'xaierg:variant_c_smile5' && entity.typeId !== 'xaierg:variant_c_smile4' && entity.typeId !== 'xaierg:variant_c_smile3'&& entity.typeId !== 'xaierg:variant_a' && entity.typeId !== 'xaierg:variant_a_smile' && entity.typeId !== 'xaierg:variant_a_smile2' && entity.typeId !== 'xaierg:variant_a_smile3' && entity.typeId !== 'xaierg:variant_a_smile4'&& entity.typeId !== 'xaierg:variant_a_death'&& entity.typeId !== 'xaierg:smile_control' && entity.typeId !== 'xaierg:human_x' && entity.typeId !== 'minecraft:item') {
                block.dimension.getPlayers().forEach(player => {
                    player.runCommand(`particle xaierg:xadurgie_fog ~~~`);
                  });
                block.dimension.spawnEntity('xaierg:entity_absorber', entity.location);
                entity.kill(); 
            } else if (entity.typeId === 'minecraft:enderman') {
                entity.kill();
            }
        });
        
  
}

SERVER.world.afterEvents.entityHurt.subscribe((data) => {
    const creature = data.damageSource.damagingEntity
    if (creature.typeId != 'xaierg:entity_absorber') return;
    const victim = data.hurtEntity
    if (victim.typeId == 'minecraft:player') return;
    if (data.damage < victim.getComponent('health').currentValue) return;
    victim.runCommand('function corrupt_absorber')
    victim.remove()
})